import ij.plugin.*;
import ij.*;
import ij.io.*;
import java.awt.EventQueue;
import java.io.*;
import javax.swing.*;
import javax.swing.filechooser.*;

/**	Uses the JFileChooser from Swing to open one or more raw images.
	 The "Open All Files in Folder" check box in the dialog is ignored. */
public class Raw_File_Opener  implements PlugIn {
	private String directory;
	private File[] files;

	public void run(String arg) {
		openFiles();
	}

	public void openFiles() {
		// run JFileChooser in a separate thread to avoid possible thread deadlocks
		try {
			EventQueue.invokeAndWait(new Runnable() {
				public void run() {
					JFileChooser fc = new JFileChooser();
					fc.setMultiSelectionEnabled(true);
					File dir = null;
					String sdir = OpenDialog.getDefaultDirectory();
					if (sdir!=null)
						dir = new File(sdir);
					if (dir!=null)
						fc.setCurrentDirectory(dir);
					int returnVal = fc.showOpenDialog(IJ.getInstance());
					if (returnVal!=JFileChooser.APPROVE_OPTION)
						return;
					files = fc.getSelectedFiles();
					if (files.length==0) { // getSelectedFiles does not work on some JVMs
						files = new File[1];
						files[0] = fc.getSelectedFile();
					}
					directory = fc.getCurrentDirectory().getPath()+File.separator;
				}
			});
		} catch (Exception e) {}
		if (directory ==null)
			return;
		OpenDialog.setDefaultDirectory(directory);
		ImportDialog d = new ImportDialog();
		FileInfo fi = d.getFileInfo();
		if (fi==null)
			return;
		fi.directory = directory;
		for (int i=0; i<files.length; i++) {
			fi.fileName = files[i].getName();
			FileOpener fo = new FileOpener(fi);
			ImagePlus img = fo.open(false);
			if (img!=null) {
				if (IJ.getVersion().compareTo("1.50e")>=0)
					img.setIJMenuBar(i==files.length-1);
				img.show();
			}
		}        
	}

}
